from suds.client import Client
from suds.wsse import Security, UsernameToken
from django.conf import settings


class UMWebService(object):
    """ """

    settings_name = ""
    url = ""
    login = ""
    password = ""
    debug = ""
    client = None

    def __init__(self):
        """ """
        self.config = getattr(settings, self.settings_name, {})
        self.url = self.config.get("url", "")
        self.login = self.config.get("login", "")
        self.password = self.config.get("password", "")
        self.debug = self.config.get("debug", False)

    def in_debug(self):
        """ """
        return self.debug

    def get_client(self):
        """ """
        if not self.client and not self.in_debug():
            self.client = Client(url=self.url)
            security = Security()
            token = UsernameToken(self.login, self.password)
            security.tokens.append(token)
            self.client.set_options(wsse=security)
        return self.client

    def ping(self):
        """ """
        if self.in_debug():
            return True
        client = self.get_client()
        return client.service.Ping()


umws_service = UMWebService()
